#version 150 compatibility
// (C) 2011 Dmytry Lavrov. All rights reserved.
uniform float brightness;
uniform float interp_t;

layout(points) in;
layout(line_strip, max_vertices=2) out;

in vec3 vertex_g[];
in vec3 old_vertex_g[];
out vec3 delta;
out vec3 color;

void emit_one(in float extra_t)
{
	vec3 interp_vert=old_vertex_g[0] + (vertex_g[0]-old_vertex_g[0]) * (interp_t + extra_t);
	vec4 pos = gl_ModelViewProjectionMatrix * vec4(interp_vert, 1.0);
	delta=(gl_ModelViewMatrix*pos).xyz;
	gl_Position=pos;
	color=gl_in[0].gl_FrontColor.rgb;
	EmitVertex();
}

void main(void)
{
	emit_one(-0.7);
	emit_one(0.0);
	EndPrimitive();
}
