if not main_loaded then
require("main")
end

LogMessage("+love")

local startpos={0,0,0}
local pos={0,0,0}
local scale=2.0;
local pts_density=1;

if not PtTransform then
	function PtTransform(p)
		return p
	end
end

if not VTransform then
	function VTransform(p)
		return p
	end
end

local font={
	[" "]={
		delta=2,
		lines={}
	},
	["I"]={
		delta=0,
		lines={0,0,  0,4, 1}
	},
	["L"]={
	delta=2,
	lines={0,0,  0,4, 1,
				2,0,  0,0, 1}
	},
	["O"]={
	delta=2,
	lines=
		{
			1,0,  0,2, 0,
			0,2,  1,4, 0,
			1,4,	2,2, 0,
			2,2,  1,0, 0,
		}
	},
	["V"]={
		delta=4,
		lines={
			0,4,  2,0, 0,
			2,0,  4,4, 1,
		}
	},
	["E"]={
		delta=2,
		lines={
		0,4,  0,0, 1,
		2,4,  0,4, 0,
		2,2,  0,2, 0,
		2,0,  0,0, 0,
		}
	},

	["Y"]={
		delta=2,
		lines={
		0,4,  1,2, 0,
		1,2,  2,4, 1,
		1,0,  1,2, 0,
		}
	},

	["U"]={
		delta=3,
		lines={
		0,4,  0,1, 0,
		0,1,  1,0, 0,
		1,0,  2,0, 0,
		2,0,  3,1, 0,
		3,1,  3,4, 1,
		}
	},

	["S"]={
		delta=3,
		lines={
		3,4,  1,4, 0,
		1,4,  0,3, 0,
		0,3,  1,2, 0,
		1,2,  2,2, 0,
		2,2,  3,1, 0,
		3,1,  2,0, 0,
		2,0,  0,0, 1,
		}
	},


	["A"]={
		delta=4,
		lines={
		0,0,  2,4, 0,
		2,4,  4,0, 1,
		1,2,  3,2, 1,
		}
	},

	["R"]={
		delta=3,
		lines={
		0,0,  0,4, 0,
		0,4,  2,4, 0,
		2,4,  3,3, 0,
		3,3,  2,2, 0,
		2,2,  0,2, 0,
		3,0,  2,2, 0,
		}
	},

}

function Script:SpawnMeteorites()
	-- override
end

function DrawPoint(p)
	Sleep(0.05)
	NewGameObject{
	type="Meteorites",
	pos=PtTransform({p[1]*scale+pos[1],p[2]*scale+pos[2],pos[3]}),
	vel=VTransform({0,0,10}),
	lifetime=100,
	brightness=1,
	mass=2
	}
	--LogMessage("Spawned meteorites at" .. table.tostring(p))
end

function DrawLine(p1,p2)
	local delta=SubVec(p2,p1)
	local l=Len(delta)
	local npts=math.ceil(l*pts_density)
	for i=0, npts-1 do
		DrawPoint(AddVec(p1,ScaleVec(delta,i/npts)))
	end
end

function DrawLines(lines)
	for i=1, #lines-1, 5 do
			DrawLine({lines[i],lines[i+1]},{lines[i+2],lines[i+3]})
			if lines[i+4] then
				DrawPoint({lines[i+2],lines[i+3]})
			end
		end
end

function DrawChar(c)
	LogMessage("DrawChar ".. c)
	local a=font[c]
	if a then
		if a.lines then
			DrawLines(a.lines)
		end
		pos[1]=pos[1]+(a.delta+0.5)*scale
	end
end

function DrawString(s)
	for i=1,s:len() do
		DrawChar(s:sub(i,i))
	end
end

function StringWidth(s)
	local result=0
	for i=1,s:len() do
		local c=s:sub(i,i)
		result=result+font[c].delta*scale
	end
	if s:len()>1 then
		result=result+0.5*(s:len()-1)*scale
	end
	return result
end

function Script:ILoveYou()
	while true do -- the love is forever
		pos[1]=startpos[1]
		pos[2]=startpos[2]
		pos[3]=startpos[3]

		pos[1]=startpos[1]-0.5*StringWidth("SARA")
		DrawString("SARA")
		pos[1]=startpos[1]-0.5*StringWidth("I LOVE")
		pos[2]=pos[2]-5.5*scale
		DrawString("I LOVE")
		pos[1]=startpos[1]-0.5*StringWidth("YOU")
		pos[2]=pos[2]-5.5*scale
		DrawString("YOU")
		--DrawString("SARA I LOVE YOU")
		--Sleep(5)
	end
end
local text_width=StringWidth("I LOVE")

local pi=3.141592
function Script:Heart()
	local cx=0
	local cy=-6*scale
	while true do
		for a=0, pi, pi/20 do
			local x=math.sin(a)*15*scale
			local y=math.cos(a)*15*scale+x*1.3
			NewGameObject{
				type="Meteorites",
				pos=PtTransform{cx+x,cy+y,pos[3]},
				vel=VTransform{0,0,10},
				lifetime=100,
				brightness=1,
				mass=10,
				min_speed=0.5
			}

			NewGameObject{
				type="Meteorites",
				pos=PtTransform{cx-x,cy+y,pos[3]},
				vel=VTransform{0,0,10},
				lifetime=100,
				brightness=1,
				mass=10,
				min_speed=0.5
			}
			Sleep(0.2)
		end
		--Sleep(5)
	end
end
