LogMessage("running 000_script.lua ")
require("main")

local parent_on_game_frame=on_game_frame

table.insert(hints,
{
name="difficulty",
text=_T("Press esc and set\nthe difficulty to insane"),
audio="$$data/hint_difficulty.ogg",
f=function()
	return (GetOption("game/difficulty")+0)~=1
end
}
)

function on_game_frame(dt)
	parent_on_game_frame(dt)
	--[[
	if SyncedRandom()<0.005 then
		local chewer=NewGameObject({type="Chewer", pos={RandomPoint()}})
	end
	--]]
	--LogMessage("level script game frame")
end


local my_pos={135.537, 49.0178, 13.7896};


function Script:SpawnLevelPortals()
end

function Script:SpawnStartBonus()
end

function Script:SpawnExplanation()
	local xpos_start=-30
	local xpos=xpos_start
	local xdelta=5
	local ypos=22
	local ydelta=5
	local zpos=-70
	local text_scale=0.1
	local function SpawnObj(t)
		local obj_t={
			locked=true,
			orientation=MulQuatQuat(my_state.orientation,AxisAngleToQuaternion({0,1,0},math.pi))
		}
		for k,v in pairs(t) do
			obj_t[k]=v
		end
		local cnt=t.count or 1
		for a=1,cnt do
			xpos=xpos+xdelta*0.5
			obj_t.pos=LocalToGlobalPos{xpos,ypos,zpos}
			obj_t.old_pos=LocalToGlobalPos{xpos,ypos,zpos}
			NewGameObject(obj_t)
			xpos=xpos+xdelta*0.5
		end
	end
	local function SpawnText(text, text_color)
		local id=NewBillboard{
			lifetime=1000,
			offset={xpos,ypos,zpos},
			align={0,0.5},
			text=text,
			color=text_color,
			scale=text_scale
		}
		local tmp={text_render_size=true}
		GetObjectState(id, tmp)
		--xpos=xpos+8*(#text)*text_scale
		xpos=xpos+tmp.text_render_size[1]
	end
	local function eol()
		xpos=xpos_start
		ypos=ypos-ydelta
	end
	local function space(n)
		xpos=xpos+8*n*text_scale
	end

	local function SpawnObj2(t)
		local obj_t={
			locked=true,
			orientation=MulQuatQuat(my_state.orientation,AxisAngleToQuaternion({0,1,0},math.pi))
		}
		for k,v in pairs(t) do
			obj_t[k]=v
		end
		local cnt=t.count or 1
		for a=1,cnt do
			xpos=xpos+xdelta*0.5
			obj_t.pos=LocalToGlobalPos(t.offset)
			obj_t.old_pos=LocalToGlobalPos(t.offset)
			NewGameObject(obj_t)
			xpos=xpos+xdelta*0.5
		end
	end

-- disabled until next Christmas
--[[
	local xmas_y=30
	local wh_radius=3
	SpawnObj2{
		type="LevelPortal",
		level=-1,
		orientation=my_state.orientation,
		offset={0,xmas_y,zpos},
		size=3
	}
	NewBillboard{
		lifetime=1000,
		offset={-wh_radius,xmas_y,zpos},
		align={1,0.5},
		text="Merry",
		color=text_color,
		scale=0.2
	}
	NewBillboard{
		lifetime=1000,
		offset={wh_radius,xmas_y,zpos},
		align={0,0.5},
		text="Christmas",
		color=text_color,
		scale=0.2
	}
]]
	SpawnText(
	string.upper(
	_T(
[[* GAMEPLAY: Your goal is to top the scores, by using the items below.
* When you're done looking around, press esc and set difficulty to insane, you'll
   never be able to get very big score on easy, because on easy you dont get enough enemies.
* The "per past 5 minutes" phrase actually has some meaning.
* Watch how score changes, find a way to exploit scoring function. Good luck!]]
)
),
{0.25, 0.35, 1}
)
	eol()
	if do_japanese_hacks then
		ypos=ypos-1
	end

	SpawnObj{type="Chewer", count=3, reload_timer=100}
	SpawnText(_T("Nom-Noms, nazi robots whom eats ghosts and try to shoot you. "))
	SpawnText(_T("Kill them."), {3, 0.4, 0.1})
	eol()
	local friend_action_color={0.4, 1, 0.1}

	--[[
	for i=1,400 do
		SpawnObj{type="Fighter", seed_id=i}
		SpawnText(i .. "")
		if i%20 == 0 then
			eol()
		end
	end]]
	SpawnObj{type="Fighter", seed_id=2}
	SpawnObj{type="Fighter", seed_id=5}
	SpawnObj{type="Fighter", seed_id=224}
	SpawnText(_T("Ghosts - friends whom repair you and give you speed boost. "))
	SpawnText(_T("Fly through."), friend_action_color)
	eol()
	SpawnObj{type="Flower", count=6}
	SpawnText(_T("Flowers - friends you can hide in. "))
	SpawnText(_T("Fly through."), friend_action_color)
	eol()
	SpawnObj{type="LevelPortal", level=GetOption("game/arena")+1, orientation=my_state.orientation }
	--[[
	if GetOption("misc/seen_christmas_tree")=="1" then
		SpawnObj{type="LevelPortal", level=GetOption("game/arena")+1, orientation=my_state.orientation }
	else
		SpawnObj{type="LevelPortal", level=36, orientation=my_state.orientation }
	end
	]]
	SpawnText(_T("<-- Fly through this wormhole when you want to go to the next arena!"), {3, 0.4, 0.1} )
	eol()
	SpawnObj{type="LevelPortal2", visualizer=GetOption("game/music_visualizer")+1, orientation=my_state.orientation}
	SpawnText(_T("Wormhole to next animator. Fly through."))

	eol()
	SpawnObj{type="AcceleratorSegment", count=3}
	SpawnText(_T("Rings that deflect bullets weirdly."))
	eol()
	SpawnObj{type="SimpleBonusPod", bonus_id=0}
	space(-1)
	SpawnText(_T("Fast bullets."))
	space(2)
	SpawnObj{type="SimpleBonusPod", bonus_id=1}
	space(-1)
	SpawnText(_T("Autoaim."))
	space(2)
	SpawnObj{type="SimpleBonusPod", bonus_id=2}
	space(-1)
	SpawnText(_T("Speed boost. "))
	SpawnText(_T("Collect."), friend_action_color)

	eol()
	SpawnText(_T("Near the attractor, your ship flies 2x faster.\nWith speed boost, it flies 3x faster. With both, 6x"))

	Sleep(5)
	NewBillboard{text="", offset={0,100,0}, audio="$$data/level1_toptext.ogg"}
	--so={pos={0,0,0}, file="$$data/level1_toptext.ogg", lifetime=1000, vel=my_state.vel, sound_gain=1, sound_pitch=1}
	--NewSound(so)
end

-- disabled until next Christmas
--[[
function Script:GoSeeTree()
	Sleep(180)
	if GetOption("misc/seen_christmas_tree")=="1" then
		return
	end
	--local my_state={}
	--GetObjectState(GetMyID(), my_state)
	--LogMessage("my_state=", table.tostring(my_state))
	local q=my_state.orientation
	local portal_pos=AddVec(my_state.pos, MulQuatVec(q, {0,0,-40}))
	NewGameObject{
	type="LevelPortal",
	pos=portal_pos,
	orientation=MulQuatQuat(my_state.orientation,AxisAngleToQuaternion({1,0,0},SyncedRandom()*math.pi/8)),
	level=-1,
	fade_in_time=5,
	size=3
	}
	NewBillboard{
		lifetime=100,
		offset={-4,0,-40},
		align={1,0.5},
		text="Merry",
		scale=0.2
	}
	NewBillboard{
		lifetime=100,
		offset={4,0,-40},
		align={0,0.5},
		text="Xmas",
		scale=0.2
	}
end
]]

--NewGameObject({type="AcceleratorSegment", pos={10,10,10}})
--[[
for i=0,5 do
	local angle=i*2.0*math.pi/6.0
	local r=7
	local p={110.537, 40.0178, 13.7896}
	NewGameObject({type="AcceleratorSegment", pos={p[1],p[2]+r*math.cos(angle),p[3]+r*math.sin(angle)}, orientation=AxisAngleToQuaternion({1,0,0},angle+math.pi/6.0)})
end

local flower1=NewGameObject({type="Flower", pos={130.537, 40.0178, 13.7896}, speed_factor=1, size=1, draw_bv=false})
SetObjectState(flower1, {size=2} )


for i=0, 2 do
	for j=0, 2 do
		local chewer=NewGameObject({type="Chewer", pos={80.537+j*3, 0.0, 13.7896+i*3}})
	end
end
--]]
